package com.factory.controller.wx;

import com.factory.base.entity.aggregates.PageBean;
import com.factory.base.entity.aggregates.ResponseBean;
import com.factory.base.entity.po.benteler.BentelerPlan;
import com.factory.base.util.res.ResponseBeanBuilder;
import com.factory.wx.entity.req.PlanApprovalTaskReq;
import com.factory.wx.entity.req.PlanInfoReq;
import com.factory.wx.entity.req.PlanPageReq;
import com.factory.wx.entity.res.PlanPassDetailRes;
import com.factory.wx.service.PlanPassService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 微信小程序端计划
 *
 * @author sMArT
 * @version 1.0
 * @date 2021-07-05 3:06 下午
 */
@Api(tags = "微信小程序端")
@RestController
@RequestMapping("/plans/pass")
@Slf4j
public class PlanPassController {

    @Autowired
    private PlanPassService planPassService;

    @ApiOperation(value = "计划放行列表")
    @PostMapping("/list")
    public ResponseBean<PageBean<BentelerPlan>> pass(@RequestBody PlanPageReq planPageReq) {
        PageBean<BentelerPlan> passList = planPassService.getPassListByPage(planPageReq);
        return ResponseBeanBuilder.ok(passList);
    }

    @ApiOperation(value = "计划放行详情")
    @PostMapping("/detail")
    public ResponseBean<PlanPassDetailRes> passDetail(@RequestBody PlanInfoReq planInfoReq) {
        PlanPassDetailRes planPassDetailRes = planPassService.getPassDetail(planInfoReq);
        return ResponseBeanBuilder.ok(planPassDetailRes);
    }

    @ApiOperation(value = "计划放行")
    @PostMapping("/operate")
    public ResponseBean passOperate(@RequestBody PlanApprovalTaskReq planApprovalTaskReq) {
        return planPassService.approvalTaskOperate(planApprovalTaskReq);
    }

}
