package com.factory.web.entity.fa.req;

import java.time.LocalDate;
import java.util.List;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.Size;

import com.factory.web.entity.fa.FirstArticleTitle;
import com.fasterxml.jackson.annotation.JsonInclude;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 修改首件计划
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class EditFaPlanReq {
	
	@ApiModelProperty(value = "计划ID")
	private Long bentelerPlanId;

	@Size(max = 128, message = "名字长度过长")
	@NotEmpty(message = "计划名称不能为空")
	@ApiModelProperty(value = "计划名称", example = "计划A")
	private String bentelerPlanName;

	@ApiModelProperty(value = "生效日期", example = "2021-06-06")
	private LocalDate effectiveDate;

	@ApiModelProperty(value = "日周月点检规则")
	private List<FirstArticleCalendarReq> firstArticleCalendarList;

	@ApiModelProperty(value = "表头信息")
	private FirstArticleTitle firstArticleTitle;

	@ApiModelProperty(value = "工作站及巡检内容")
	private List<FirstArticleWorkshopReq> firstArticleWorkshopList;
}
