package com.jihengbel.intelligent.applicationtask.service.impl;

import com.jihengbel.intelligent.applicationtask.entry.OnsiteCalendar;
import com.jihengbel.intelligent.applicationtask.entry.OnsiteTask;
import com.jihengbel.intelligent.applicationtask.model.OnsiteTaskMapper;
import com.jihengbel.intelligent.applicationtask.service.OnsiteTaskService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

@Service("onsiteTaskServiceImp")
public class OnsiteTaskServiceImp implements OnsiteTaskService {



    @Autowired
    OnsiteTaskMapper mapper;

    @Override
    @Transactional(rollbackFor = Throwable.class)
    public int insertOnsiteTask(OnsiteTask task) {
        return mapper.insertOnsiteTask(task);
    }


    /**
     * 获取对应的规则
     * @param paarm
     * @return
     */
    public List<OnsiteCalendar> getCalenderOnsitesForType(Map<String,Object> param){
        return mapper.getCalenderOnsitesForType(param);
    }

    /**
     * 需要提醒的工作
     * @param param
     * @return
     */
    public List<OnsiteCalendar> getRemindWork(Map<String,Object> param){
        return mapper.getRemindWork(param);
    }

    /**
     *  更新提醒状态，不太好的写法但是符合现在的需求
     * @param param
     * @return
     */
    public int updateOnsiteRemindFlag(Map<String,Object> param){
        return mapper.updateOnsiteRemindFlag(param);
    }




    /**
     * 获取需要提醒人
     * @param map
     * @return
     */
    public Long getRemindNoworkToManager(Map map){
        return mapper.getRemindNoworkToManager(map);
    }

    /**
     * 添加不工作提醒信息
     * @param map
     * @return
     */
    @Transactional(rollbackFor = Throwable.class)
    public int addRemindNowork(Map map){
        int result= mapper.addRemindNowork(map);
        mapper.updateOnsiteRemindFlag(map);
        return result;

    }
}
